/* Process model C form file: UniApp.pr.c */
/* Portions of this file copyright 1992, 1996, 1998 by MIL 3, Inc. */



/* This variable carries the header into the object file */
static const char UniApp_pr_c [] = "MIL_3_Tfile_Hdr_ 60L 30A op_runsim 7 38FBBA8A 38FBBA8A 1 chrono.ite.gmu.edu vmukkama 0 0 none none 0 0 none 0 0 0 0 0 0";


/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define	TRACE	if(0)

/*
** This are the conditions for transitions to got to different states from the idle block
*/
#define	PK_ARR		op_intrpt_type () == OPC_INTRPT_STRM
#define	SELF_INT1	op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 0
#define END_SIM		op_intrpt_type () ==  OPC_INTRPT_ENDSIM

/*
** Different probes that are used to meausure the number of data packets sent, no. of data
** packets received by this module (or process)
*/
#define CUMM_UAPP_PKT_SENT_STAT	0
#define CUMM_PKT_RECV_STAT  	1
#define AVG_PKT_RECV_STAT   	2

/* Added by Dg and Jiemei */
#define Node_RSVP_AVG_DELAY 3
#define Node_BE_AVG_DELAY   4
#define Total_RSVP_AVG_DELAY 5
#define Total_BE_AVG_DELAY 6

#define send_data_intr      0
#define IP_STREAM           0

#define Meas_Intvl          1

#define UDP_PROTOCOL_ID     20

#define ON                  1
#define OFF                 0

#define VL                  if(ON)
#define UADL                if(OFF)
#define UAREVDL             if(OFF)

#define PROBE_ON            if(ON)
#define PROBE_OFF           if(OFF)

typedef struct 
{
	int NetNum;
	int NodeNum;
}IPAddress;

typedef struct 
{
	char Message[500];
}App_Data;

double NoOfUappPktsSent,NoOfPktsRecv;
double Total_RSVP_Delay;
double Total_BE_Delay;
double Total_RSVP_Pkts;
double Total_BE_Pkts;


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Objid                   		my_objid;
	Objid                   		ip_objid;
	double                  		data_iat;
	double                  		print_time;
	int                     		MAX_NO_NETS;
	int                     		MAX_NO_NODES;
	int                     		DataSendInitTime;
	Distribution*           		net_dist;
	Distribution*           		node_dist;
	IPAddress               		LocalAddress;
	double                  		Node_RSVP_Delay;
	double                  		Node_BE_Delay;
	double                  		Node_RSVP_Pkts;
	double                  		Node_BE_Pkts;
	} UniApp_state;

#define pr_state_ptr            		((UniApp_state*) SimI_Mod_State_Ptr)
#define my_objid                		pr_state_ptr->my_objid
#define ip_objid                		pr_state_ptr->ip_objid
#define data_iat                		pr_state_ptr->data_iat
#define print_time              		pr_state_ptr->print_time
#define MAX_NO_NETS             		pr_state_ptr->MAX_NO_NETS
#define MAX_NO_NODES            		pr_state_ptr->MAX_NO_NODES
#define DataSendInitTime        		pr_state_ptr->DataSendInitTime
#define net_dist                		pr_state_ptr->net_dist
#define node_dist               		pr_state_ptr->node_dist
#define LocalAddress            		pr_state_ptr->LocalAddress
#define Node_RSVP_Delay         		pr_state_ptr->Node_RSVP_Delay
#define Node_BE_Delay           		pr_state_ptr->Node_BE_Delay
#define Node_RSVP_Pkts          		pr_state_ptr->Node_RSVP_Pkts
#define Node_BE_Pkts            		pr_state_ptr->Node_BE_Pkts

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	UniApp_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void UniApp (void);
	Compcode UniApp_init (void **);
	void UniApp_diag (void);
	void UniApp_terminate (void);
	void UniApp_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
UniApp (void)
	{
	int _block_origin = 0;
	FIN (UniApp ());
	if (1)
		{
		double thru, thru1, tmpDataRec, tmpDataSend, tmp_sim_time, thru2, thru3;
		Packet*  pkptr;
		int in_strm,da1,da2,da3;
		FILE*  fil;
		


		FSM_ENTER (UniApp)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "UniApp () [init enter execs]")
				{
				/*******************************************************************************************
				** Process Model : Uniapp                                                                 **
				** State         : init                                                                   **
				**                                                                                        **
				** This block intializes the variables that will be used in this process model, loads the **
				** distributions that are used to select the destination address to which the data packet **
				** is sent. It also  gets the object id of the IP module and  the IP address of this host **
				** from that IP module. This also schedules an interrupt for sending data after some init **
				** time. This  init time is given  so that this unicast application doesn't send any data **
				** before all the routing tables are initialized.                                         **
				**                                                                                        **
				*******************************************************************************************/
				
				/*
				** Get the present module's  object ID and load the attributes from  the configuaration file
				*/
				my_objid = op_id_self();
				
				
				op_ima_obj_attr_get( my_objid, "MaxNets", &MAX_NO_NETS );
				op_ima_obj_attr_get( my_objid, "MaxNodes", &MAX_NO_NODES );
				op_ima_obj_attr_get( my_objid, "InitTime", &DataSendInitTime );
				op_ima_obj_attr_get( my_objid,"DATA_IAT", &data_iat);
				
				/*added by Jiemei*/
				/*DataSendInitTime=10;
				data_iat=0.1;*/
				
				NoOfUappPktsSent = 0;
				NoOfPktsRecv = 0;
				
				Node_RSVP_Delay = 0;
				Node_BE_Delay = 0;
				Node_RSVP_Pkts = 0; 
				Node_BE_Pkts = 0;
				
				Total_RSVP_Delay = 0;
				Total_BE_Delay = 0;
				Total_RSVP_Pkts = 0;
				Total_BE_Pkts = 0;
				
				
				/*printf("UniApp: MyObjId  %d  MaxNets %d  MaxNodes %d  DataSendInitTime %d  DataIat %f\n",my_objid,MAX_NO_NETS,MAX_NO_NODES,DataSendInitTime,data_iat); */ 
				
				/* 
				** Get the IP module's Object Id  and use this object id to  get the IP address  of the host
				*/
				ip_objid = op_topo_assoc (my_objid, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_MODULE, 0);
				op_ima_obj_attr_get( ip_objid, "net_num0", &LocalAddress.NetNum );
				op_ima_obj_attr_get( ip_objid, "node_num0", &LocalAddress.NodeNum );
				
				/*
				** Load the distribution pointers for selecting the destination address for the data packet 
				** that is being sent from this state
				*/
				net_dist = op_dist_load("uniform_int", 1, MAX_NO_NETS );
				node_dist = op_dist_load("uniform_int", 0, MAX_NO_NODES );
				
				/*
				** Schedule the interrupt to send the data packets 
				*/
				op_intrpt_schedule_self( (op_sim_time() + data_iat + DataSendInitTime), send_data_intr );
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "UniApp () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "UniApp () [idle enter execs]")
				{
				/*added by Jiemei */
				
				/* if (op_sim_time()>10) printf ("UniApp: sent %f receive %f\n",NoOfPktsSent,NoOfPktsRecv); */
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,UniApp)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle", "UniApp () [idle exit execs]")
				{
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (PK_ARR)
			FSM_TEST_COND (SELF_INT1)
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (pk_arr) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "pk_arr", "UniApp () [pk_arr enter execs]")
				{
				
				/*****************************************************************************************************
				** Process Model : Uniapp                                                                           **
				** State         : pk_arr                                                                           **
				**                                                                                                  **
				** This is a port for all the traffic(packets  with protocol ID as 20) that was destinated for this **
				** host. The state upon receiving the packet updates the counter which keeps track of the number of **
				** packets received  by this host. It writes this statistics into a probe file which can be plotted **
				** once the simulation is completed. It destroys the packets that are received.                     **
				**                                                                                                  **
				*****************************************************************************************************/
				
				/*added by Jiemei, Mar 28, 97*/
				int src_net, src_node, id, treeid;
				App_Data* DataRecv;
				Packet *dataptr;
				char msgtype[10];
				float senttime; 
				double delay;
				
				pkptr  = op_pk_get (op_intrpt_strm ());
				
				/*
				** Probe to measure the number of data packets received by this UDP port
				*/
				PROBE_ON
				{
					NoOfPktsRecv++;
					op_stat_local_write( CUMM_PKT_RECV_STAT, NoOfPktsRecv );
				/* Added by DG and Jiemei, 11/27/97 */
				
					op_pk_nfd_get(pkptr, "data", &dataptr );
					op_pk_nfd_get(dataptr, "UniData", &DataRecv );
					sscanf( DataRecv -> Message, "%s %f", msgtype, &senttime );
				printf( "\n=== %s %s %f\n", DataRecv -> Message, msgtype, senttime );
					delay = op_sim_time() - senttime;
				
					if ( msgtype[0] == 'R' )
					{
						Total_RSVP_Delay += delay;
						Total_RSVP_Pkts ++;
						op_stat_local_write( Total_RSVP_AVG_DELAY, Total_RSVP_Delay / Total_RSVP_Pkts );
				
						Node_RSVP_Delay += delay;
						Node_RSVP_Pkts ++;
						op_stat_local_write( Node_RSVP_AVG_DELAY, Node_RSVP_Delay / Node_RSVP_Pkts );
					}
					else	/* Best-effort */
					{
						Total_BE_Delay += delay;
						Total_BE_Pkts ++;
						op_stat_local_write( Total_BE_AVG_DELAY, Total_BE_Delay / Total_BE_Pkts );
				
						Node_BE_Delay += delay;
						Node_BE_Pkts ++;
						op_stat_local_write( Node_BE_AVG_DELAY, Node_BE_Delay / Node_BE_Pkts );
					}
				
				}
				PROBE_OFF
				{
					tmpDataRec++;
					if(op_sim_time() > tmp_sim_time + Meas_Intvl )
					{
						thru1 = tmpDataRec/Meas_Intvl;
						op_stat_local_write( AVG_PKT_RECV_STAT, thru1);
						tmpDataRec = 0;
						tmp_sim_time = tmp_sim_time + Meas_Intvl;
					}
				}
				
				/*added by Jiemei*/
				VL{
				op_pk_nfd_get(pkptr,"src_net",&src_net);
				op_pk_nfd_get(pkptr,"src_node",&src_node);
				printf( "   %fs, (%d,%d) UAPP get packet from (%d, %d)\n", 
					op_sim_time(),LocalAddress.NetNum, LocalAddress.NodeNum, src_net, src_node );
				}
				
				
				op_prg_mem_free (DataRecv);
				op_pk_destroy (dataptr);
				op_pk_destroy (pkptr);
				
				}


			/** state (pk_arr) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "pk_arr", "UniApp () [pk_arr exit execs]")
				{
				}


			/** state (pk_arr) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (data) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "data", "UniApp () [data enter execs]")
				{
				/*******************************************************************************************
				** Process Model : Uniapp                                                                 **
				** State         : data                                                                   **
				**                                                                                        **
				** This block selects a destination address randomly(from the uniform distributions) from **
				** the networks that are present into the model. It packs the data packet encapsulates it **
				** into the IP datagram and sends the packet to the IP layer. The message is of 500 bytes **
				** length. This block also keeps track of the no. of packets sent by this host and writes **
				** this  statistic into a probe file that can  plotted through the analysis tool. It also **
				** schedules an interrput for sending the next data packet.                               **
				**                                                                                        **
				*******************************************************************************************/
				
				App_Data* DataSent;  /*changed by Jiemei Mar 27, 97*/
				Packet* ip_pkptr;
				int dest_net, dest_node, data_len;
				
				/*
				** Get the destination address from the uniform distributions
				*/
				dest_net = op_dist_outcome( net_dist );
				dest_node = op_dist_outcome( node_dist );
				
				
				DataSent=(App_Data *) op_prg_mem_alloc(sizeof(App_Data));   /*added by Jiemei, Mar 27,97*/
				sprintf( DataSent->Message, "UAPP  %f Src %d %d Dest %d %d\n", op_sim_time(), 
						LocalAddress.NetNum, LocalAddress.NodeNum,
						dest_net, dest_node );	/*added by Jiemei, Mar 27,97*/
				
				
				TRACE VL printf("UApp: %fs (%d.%d)send data to (%d.%d)\n", 
						op_sim_time(), LocalAddress.NetNum, LocalAddress.NodeNum,
						dest_net, dest_node );
				
				/*
				** Create the data packet and load it with data
				*/
				pkptr = op_pk_create_fmt("Unicast_Appl");
				
				op25_pk_nfd_set(pkptr, "UniData", DataSent, op_prg_mem_alloc,op_prg_mem_free, sizeof(App_Data));
				
				data_len = op_pk_total_size_get( pkptr )/8;
				
				/*
				** Encapsulate the data packet into the IP datagram by filling the sender address, destination 
				** address, data length, protocol Id and time-to-live
				*/
				ip_pkptr = op_pk_create_fmt("ip_dgram");
				op25_pk_nfd_set(ip_pkptr, "data", pkptr );
				op25_pk_nfd_set(ip_pkptr, "prot_id", UDP_PROTOCOL_ID );
				op_pk_bulk_size_set(ip_pkptr, data_len*8 );
				op25_pk_nfd_set(ip_pkptr, "dest_net", dest_net );
				op25_pk_nfd_set(ip_pkptr, "dest_node", dest_node );
				op25_pk_nfd_set(ip_pkptr, "src_net", LocalAddress.NetNum );
				op25_pk_nfd_set(ip_pkptr, "src_node", LocalAddress.NodeNum );
				op25_pk_nfd_set(ip_pkptr, "orig_len", data_len );
				op25_pk_nfd_set(ip_pkptr, "frag_len", data_len );
				op25_pk_nfd_set(ip_pkptr, "ttl", 2);   
				op25_pk_nfd_set(ip_pkptr, "frag", 0 );
				
				op_pk_send( ip_pkptr, IP_STREAM );      /*          Send the data packet to the IP module                */
				
				
				/*
				** Write the no. of data packets sent into the probe file 
				*/
				PROBE_ON
				{
					NoOfUappPktsSent++;
					op_stat_local_write( CUMM_UAPP_PKT_SENT_STAT, NoOfUappPktsSent );
				}
				
				/*
				** Schedule the interrupt to send the data packet again
				*/
				op_intrpt_schedule_self( (op_sim_time() + (data_iat)), send_data_intr );
				
				}


			/** state (data) exit executives **/
			FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "data", "UniApp () [data exit execs]")
				{
				}


			/** state (data) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,UniApp)
		}
	}

extern
#if defined (__cplusplus)
	"C"
#endif
	void Vos_Vnop (void);


Compcode
UniApp_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (UniApp_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (UniApp)",
			sizeof (UniApp_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((UniApp_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
UniApp_diag (void)
	{
	/* No Diagnostic Block */
	}




void
UniApp_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (UniApp_terminate (void))

	if (1)
		{
		double thru, thru1, tmpDataRec, tmpDataSend, tmp_sim_time, thru2, thru3;
		Packet*  pkptr;
		int in_strm,da1,da2,da3;
		FILE*  fil;
		

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in UniApp_svar function. */
#undef my_objid
#undef ip_objid
#undef data_iat
#undef print_time
#undef MAX_NO_NETS
#undef MAX_NO_NODES
#undef DataSendInitTime
#undef net_dist
#undef node_dist
#undef LocalAddress
#undef Node_RSVP_Delay
#undef Node_BE_Delay
#undef Node_RSVP_Pkts
#undef Node_BE_Pkts



void
UniApp_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	UniApp_state		*prs_ptr;

	FIN (UniApp_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)VOS_NIL;
	prs_ptr = (UniApp_state *)gen_ptr;

	if (Vos_String_Equal ("my_objid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->my_objid);
		goto func_return;
		}
	if (Vos_String_Equal ("ip_objid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_objid);
		goto func_return;
		}
	if (Vos_String_Equal ("data_iat" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->data_iat);
		goto func_return;
		}
	if (Vos_String_Equal ("print_time" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->print_time);
		goto func_return;
		}
	if (Vos_String_Equal ("MAX_NO_NETS" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->MAX_NO_NETS);
		goto func_return;
		}
	if (Vos_String_Equal ("MAX_NO_NODES" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->MAX_NO_NODES);
		goto func_return;
		}
	if (Vos_String_Equal ("DataSendInitTime" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->DataSendInitTime);
		goto func_return;
		}
	if (Vos_String_Equal ("net_dist" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_dist);
		goto func_return;
		}
	if (Vos_String_Equal ("node_dist" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_dist);
		goto func_return;
		}
	if (Vos_String_Equal ("LocalAddress" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->LocalAddress);
		goto func_return;
		}
	if (Vos_String_Equal ("Node_RSVP_Delay" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->Node_RSVP_Delay);
		goto func_return;
		}
	if (Vos_String_Equal ("Node_BE_Delay" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->Node_BE_Delay);
		goto func_return;
		}
	if (Vos_String_Equal ("Node_RSVP_Pkts" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->Node_RSVP_Pkts);
		goto func_return;
		}
	if (Vos_String_Equal ("Node_BE_Pkts" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->Node_BE_Pkts);
		goto func_return;
		}

func_return:

	FOUT;
	}

